(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16623,        422]
NotebookOptionsPosition[     13944,        368]
NotebookOutlinePosition[     14709,        395]
CellTagsIndexPosition[     14637,        390]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Basic", " ", "Via"}], "-", 
   RowBox[{"Kernel", " ", "Example"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.875221383622593*^9, 
  3.875221401298767*^9}},ExpressionUUID->"70dc6648-6afb-4db1-a81c-\
2af56f0e73bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Button", "[", 
  RowBox[{"\"\<ClickMe\>\"", ",", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"CurrentValue", "[", "\"\<ShiftKey\>\"", "]"}], ",", 
     RowBox[{"Set", "[", 
      RowBox[{
       RowBox[{"CurrentValue", "[", 
        RowBox[{
         RowBox[{"EvaluationCell", "[", "]"}], ",", "Background"}], "]"}], 
       ",", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], "]"}], ",", 
     RowBox[{"Set", "[", 
      RowBox[{
       RowBox[{"CurrentValue", "[", 
        RowBox[{
         RowBox[{"EvaluationCell", "[", "]"}], ",", "Background"}], "]"}], 
       ",", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.875206720606696*^9, 3.875206746444004*^9}, {
  3.875206927973605*^9, 3.875206937817666*^9}, {3.875208091364904*^9, 
  3.875208121674469*^9}, {3.875213376208522*^9, 3.875213376289757*^9}, {
  3.875213672947441*^9, 3.875213673847466*^9}, {3.87522390228548*^9, 
  3.875223917630022*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"1f756c64-56ff-4559-9f65-2382c8768d9d"],

Cell[BoxData[
 ButtonBox["\<\"ClickMe\"\>",
  Appearance->Automatic,
  ButtonFunction:>If[
    CurrentValue["ShiftKey"], CurrentValue[
      EvaluationCell[], Background] = RGBColor[0, 0, 1], CurrentValue[
      EvaluationCell[], Background] = RGBColor[1, 1, 1]],
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{3.875206747574709*^9, 3.875206938267026*^9, 
  3.875207026824691*^9, 3.875208122668281*^9, 3.8752133771593924`*^9, 
  3.875213674378819*^9, 3.8752239181827908`*^9, 3.875224160352086*^9, 
  3.875270327526083*^9},
 Background->RGBColor[1, 1, 1],
 CellLabel->"Out[1]=",ExpressionUUID->"65fb87f7-2a63-4755-a082-94837c2c3e9a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Basic", " ", "No"}], "-", 
   RowBox[{"Kernel", " ", "Example"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.875221405685162*^9, 
  3.87522141822572*^9}},ExpressionUUID->"20124363-1f2b-4a67-971a-\
be0a9b4dbb84"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Button", "[", 
  RowBox[{"\"\<ClickMe\>\"", ",", 
   RowBox[{"FEPrivate`If", "[", 
    RowBox[{
     RowBox[{"CurrentValue", "[", "\"\<ShiftKey\>\"", "]"}], ",", 
     RowBox[{"FEPrivate`Set", "[", 
      RowBox[{
       RowBox[{"CurrentValue", "[", 
        RowBox[{
         RowBox[{"EvaluationCell", "[", "]"}], ",", "Background"}], "]"}], 
       ",", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], "]"}], ",", 
     RowBox[{"FEPrivate`Set", "[", 
      RowBox[{
       RowBox[{"CurrentValue", "[", 
        RowBox[{
         RowBox[{"EvaluationCell", "[", "]"}], ",", "Background"}], "]"}], 
       ",", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.875206720606696*^9, 3.875206746444004*^9}, {
  3.875206927973605*^9, 3.875206937817666*^9}, {3.875207088004141*^9, 
  3.8752071266752243`*^9}, {3.875207226232808*^9, 3.8752072263881073`*^9}, {
  3.875207610143302*^9, 3.875207614934671*^9}, {3.8752076975517282`*^9, 
  3.875207716074047*^9}, {3.875207915276824*^9, 3.875207966144422*^9}, {
  3.8752080491505623`*^9, 3.8752080696707287`*^9}, {3.875213382365494*^9, 
  3.8752133832833242`*^9}, {3.875213637443922*^9, 3.875213646070938*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"6690deb3-0bc1-4437-b80c-ee7a2bc41cf4"],

Cell[BoxData[
 ButtonBox["\<\"ClickMe\"\>",
  Appearance->Automatic,
  ButtonFunction:>FEPrivate`If[
    CurrentValue["ShiftKey"], 
    FEPrivate`Set[
     CurrentValue[
      EvaluationCell[], Background], 
     RGBColor[0, 0, 1]], 
    FEPrivate`Set[
     CurrentValue[
      EvaluationCell[], Background], 
     RGBColor[1, 1, 1]]],
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{3.8752136467235107`*^9, 3.8752241652921658`*^9, 
  3.875270354852317*^9},
 Background->RGBColor[1, 1, 1],
 CellLabel->"Out[2]=",ExpressionUUID->"684108bc-582d-4099-9520-50e32a603d72"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Kernel", " ", "LibraryLink", " ", "setup"}], " ", "*)"}]], "Input",\

 CellChangeTimes->{{3.875221422490817*^9, 
  3.875221440855204*^9}},ExpressionUUID->"cf190b0b-b76a-41b1-b5b8-\
f144b12332a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "path", "=", 
   "\"\</Users/coleca/Library/Mathematica/SystemFiles/LibraryResources/MacOSX-\
ARM64/filestatus.dylib\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.875210849859997*^9, 3.8752108517931356`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"5c1dceb5-2a46-4ea2-8208-1f1cfb0575dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"myFileSize", "=", 
   RowBox[{"LibraryFunctionLoad", "[", 
    RowBox[{"path", ",", "\"\<myFileSize\>\"", ",", 
     RowBox[{"{", "String", "}"}], ",", "Integer"}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.875210873012889*^9, 3.8752108804880333`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"81c0d131-b843-40e5-bb79-96d778062e3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"myFilePermissions", "=", 
   RowBox[{"LibraryFunctionLoad", "[", 
    RowBox[{"path", ",", "\"\<myFilePermissions\>\"", ",", 
     RowBox[{"{", "String", "}"}], ",", "String"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.87522346365914*^9, {3.875223682481588*^9, 3.875223682696663*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"5e1cf3e4-7550-4f5e-95d8-3ce67d8fea73"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"FrontEnd", " ", "LibraryLink", " ", "setup"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.8752214454228773`*^9, 
  3.875221450545079*^9}},ExpressionUUID->"428249b5-94f9-461f-ac32-\
f51b08ec111d"],

Cell[BoxData[
 RowBox[{"FE`Evaluate", "[", 
  RowBox[{"FEPrivate`LibraryFunctionLoad", "[", 
   RowBox[{
   "\"\</Users/coleca/Library/Mathematica/SystemFiles/LibraryResources/MacOSX-\
ARM64/filestatus.dylib\>\"", ",", "\"\<myFileSize\>\"", ",", 
    RowBox[{"{", "String", "}"}], ",", "Integer"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.875211028301705*^9, 3.8752110651740017`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"d9894372-9871-49b0-aa11-eee0686a1c93"],

Cell[BoxData[
 RowBox[{"FE`Evaluate", "[", 
  RowBox[{"FEPrivate`LibraryFunctionLoad", "[", 
   RowBox[{
   "\"\</Users/coleca/Library/Mathematica/SystemFiles/LibraryResources/MacOSX-\
ARM64/filestatus.dylib\>\"", ",", "\"\<myFilePermissions\>\"", ",", 
    RowBox[{"{", "String", "}"}], ",", "String"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.87522369943944*^9, {3.875224105398342*^9, 3.8752241059874563`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"058dc55e-ecae-47e2-9193-02c0dd35eb68"],

Cell[BoxData[
 RowBox[{"Column", "[", 
  RowBox[{"FE`Evaluate", "[", 
   RowBox[{"FEPrivate`ManagedLibraryInformation", "[", "]"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.87527197361119*^9, 3.875271984266994*^9}, {
  3.875272042527112*^9, 3.8752720682357893`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"d6b31541-bdc2-462b-856b-9d772ee4d4ea"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Via", "-", 
   RowBox[{"Kernel", " ", "LibraryLink", " ", "Example"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.875221488051838*^9, 
  3.8752215013928413`*^9}},ExpressionUUID->"8f4c79ab-39c1-4e2b-a3f8-\
89363cfb0cb5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Row", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Button", "[", 
     RowBox[{"\"\<File Size\>\"", ",", 
      RowBox[{"Set", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationCell", "[", "]"}], ",", "CellTags"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"ToString", "[", 
          RowBox[{"myFileSize", "[", 
           RowBox[{"CurrentValue", "[", "\"\<NotebookFullFileName\>\"", "]"}],
            "]"}], "]"}], "}"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"Button", "[", 
     RowBox[{"\"\<Permissions\>\"", ",", 
      RowBox[{"Set", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationCell", "[", "]"}], ",", "CellTags"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"ToString", "[", 
          RowBox[{"myFilePermissions", "[", 
           RowBox[{"CurrentValue", "[", "\"\<NotebookFullFileName\>\"", "]"}],
            "]"}], "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.875216728654347*^9, 3.875216853027966*^9}, {
   3.875217395908822*^9, 3.875217410949197*^9}, 3.8752175895107307`*^9, {
   3.87521762092942*^9, 3.875217627277906*^9}, {3.87521785341512*^9, 
   3.8752178828483143`*^9}, {3.875218039808632*^9, 3.875218043770356*^9}, {
   3.87522168682701*^9, 3.875221727894305*^9}, 3.8752237221634417`*^9, {
   3.875223836648242*^9, 3.8752238885441504`*^9}, {3.875223940296248*^9, 
   3.875223963207284*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"8133c873-4460-4d20-a965-b6e35e0c5521"],

Cell[BoxData[
 TemplateBox[{
   ButtonBox["\"File Size\"", ButtonFunction :> (CurrentValue[
       EvaluationCell[], CellTags] = {
       ToString[
        $CellContext`myFileSize[
         CurrentValue["NotebookFullFileName"]]]}), Appearance -> Automatic, 
    Evaluator -> Automatic, Method -> "Preemptive"], 
   ButtonBox["\"Permissions\"", ButtonFunction :> (CurrentValue[
       EvaluationCell[], CellTags] = {
       ToString[
        $CellContext`myFilePermissions[
         CurrentValue["NotebookFullFileName"]]]}), Appearance -> Automatic, 
    Evaluator -> Automatic, Method -> "Preemptive"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{3.8752238889883947`*^9, 3.875223963703225*^9, 
  3.875224181739894*^9, 3.875224296577271*^9, 3.875270769064748*^9},
 CellTags->"rw-rw-rw-",
 CellLabel->"Out[8]=",ExpressionUUID->"ae0e6a41-3e30-4ed7-93a8-05842dace799"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"No", " ", "Kernel", " ", "LibraryLink", " ", "Example"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.87522152983794*^9, 
  3.875221538506171*^9}},ExpressionUUID->"a1705f4f-5e5d-4c8a-9ba1-\
5889734327e7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Row", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Button", "[", 
     RowBox[{"\"\<File Size\>\"", ",", 
      RowBox[{"FEPrivate`Set", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationCell", "[", "]"}], ",", "CellTags"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"FEPrivate`ToString", "[", 
          RowBox[{"FEPrivate`LibraryFunctionApply", "[", 
           RowBox[{
            RowBox[{"FrontEnd`LibraryFunction", "[", 
             RowBox[{"\"\<filestatus\>\"", ",", "\"\<myFileSize\>\""}], "]"}],
             ",", 
            RowBox[{"{", 
             RowBox[{
             "CurrentValue", "[", "\"\<NotebookFullFileName\>\"", "]"}], 
             "}"}]}], "]"}], "]"}], "}"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"Button", "[", 
     RowBox[{"\"\<Permissions\>\"", ",", 
      RowBox[{"FEPrivate`Set", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationCell", "[", "]"}], ",", "CellTags"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"FEPrivate`ToString", "[", 
          RowBox[{"FEPrivate`LibraryFunctionApply", "[", 
           RowBox[{
            RowBox[{"FrontEnd`LibraryFunction", "[", 
             RowBox[{"\"\<filestatus\>\"", ",", "\"\<myFilePermissions\>\""}],
              "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "CurrentValue", "[", "\"\<NotebookFullFileName\>\"", "]"}], 
             "}"}]}], "]"}], "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.875223754220955*^9, 3.875223755856015*^9}, {
  3.875223974870081*^9, 3.875224005742001*^9}, {3.875224046357888*^9, 
  3.8752240556092443`*^9}, {3.875224211600087*^9, 3.875224215565268*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"46878bb6-5cda-40fd-b5cd-06a43935b675"],

Cell[BoxData[
 TemplateBox[{
   ButtonBox["\"File Size\"", ButtonFunction :> FEPrivate`Set[
      CurrentValue[
       EvaluationCell[], CellTags], {
       FEPrivate`ToString[
        FEPrivate`LibraryFunctionApply[
         FrontEnd`LibraryFunction["filestatus", "myFileSize"], {
          CurrentValue["NotebookFullFileName"]}]]}], Appearance -> Automatic, 
    Evaluator -> Automatic, Method -> "Preemptive"], 
   ButtonBox["\"Permissions\"", ButtonFunction :> FEPrivate`Set[
      CurrentValue[
       EvaluationCell[], CellTags], {
       FEPrivate`ToString[
        FEPrivate`LibraryFunctionApply[
         FrontEnd`LibraryFunction["filestatus", "myFilePermissions"], {
          CurrentValue["NotebookFullFileName"]}]]}], Appearance -> Automatic, 
    Evaluator -> Automatic, Method -> "Preemptive"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.8752240576331367`*^9, {3.875224188633102*^9, 3.875224216629715*^9}, 
   3.8752242978264713`*^9, 3.8752708232232113`*^9},
 CellTags->"rw-rw-rw-",
 CellLabel->"Out[9]=",ExpressionUUID->"475054b5-c334-4009-872a-7dd66c53c183"]
}, Open  ]]
},
Evaluator->"LinkSnooper",
WindowSize->{808, 910},
WindowMargins->{{Automatic, 94}, {Automatic, 11}},
ShowCellTags->True,
Background->RGBColor[1, 1, 1],
FrontEndVersion->"13.1 for Mac OS X ARM (64-bit) (June 16, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"b64dc307-0c09-470c-9049-d46c21336560"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "rw-rw-rw-"->{
  Cell[9807, 265, 868, 18, 60, "Output",ExpressionUUID->"ae0e6a41-3e30-4ed7-93a8-05842dace799",
   CellTags->"rw-rw-rw-"],
  Cell[12844, 342, 1084, 23, 60, "Output",ExpressionUUID->"475054b5-c334-4009-872a-7dd66c53c183",
   CellTags->"rw-rw-rw-"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"rw-rw-rw-", 14365, 382}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 275, 7, 30, "Input",ExpressionUUID->"70dc6648-6afb-4db1-a81c-2af56f0e73bb"],
Cell[CellGroupData[{
Cell[858, 31, 1150, 28, 73, "Input",ExpressionUUID->"1f756c64-56ff-4559-9f65-2382c8768d9d"],
Cell[2011, 61, 664, 14, 46, "Output",ExpressionUUID->"65fb87f7-2a63-4755-a082-94837c2c3e9a"]
}, Open  ]],
Cell[2690, 78, 273, 7, 30, "Input",ExpressionUUID->"20124363-1f2b-4a67-971a-be0a9b4dbb84"],
Cell[CellGroupData[{
Cell[2988, 89, 1383, 30, 73, "Input",ExpressionUUID->"6690deb3-0bc1-4437-b80c-ee7a2bc41cf4"],
Cell[4374, 121, 598, 18, 46, "Output",ExpressionUUID->"684108bc-582d-4099-9520-50e32a603d72"]
}, Open  ]],
Cell[4987, 142, 241, 6, 30, "Input",ExpressionUUID->"cf190b0b-b76a-41b1-b5b8-f144b12332a7"],
Cell[5231, 150, 324, 7, 73, "Input",ExpressionUUID->"5c1dceb5-2a46-4ea2-8208-1f1cfb0575dc"],
Cell[5558, 159, 373, 8, 30, "Input",ExpressionUUID->"81c0d131-b843-40e5-bb79-96d778062e3d"],
Cell[5934, 169, 406, 8, 30, "Input",ExpressionUUID->"5e1cf3e4-7550-4f5e-95d8-3ce67d8fea73"],
Cell[6343, 179, 246, 6, 30, "Input",ExpressionUUID->"428249b5-94f9-461f-ac32-f51b08ec111d"],
Cell[6592, 187, 468, 8, 73, "Input",ExpressionUUID->"d9894372-9871-49b0-aa11-eee0686a1c93"],
Cell[7063, 197, 498, 9, 73, "Input",ExpressionUUID->"058dc55e-ecae-47e2-9193-02c0dd35eb68"],
Cell[7564, 208, 353, 7, 30, "Input",ExpressionUUID->"d6b31541-bdc2-462b-856b-9d772ee4d4ea"],
Cell[7920, 217, 272, 7, 30, "Input",ExpressionUUID->"8f4c79ab-39c1-4e2b-a3f8-89363cfb0cb5"],
Cell[CellGroupData[{
Cell[8217, 228, 1587, 35, 115, "Input",ExpressionUUID->"8133c873-4460-4d20-a965-b6e35e0c5521"],
Cell[9807, 265, 868, 18, 60, "Output",ExpressionUUID->"ae0e6a41-3e30-4ed7-93a8-05842dace799",
 CellTags->"rw-rw-rw-"]
}, Open  ]],
Cell[10690, 286, 254, 6, 30, "Input",ExpressionUUID->"a1705f4f-5e5d-4c8a-9ba1-5889734327e7"],
Cell[CellGroupData[{
Cell[10969, 296, 1872, 44, 199, "Input",ExpressionUUID->"46878bb6-5cda-40fd-b5cd-06a43935b675"],
Cell[12844, 342, 1084, 23, 60, "Output",ExpressionUUID->"475054b5-c334-4009-872a-7dd66c53c183",
 CellTags->"rw-rw-rw-"]
}, Open  ]]
}
]
*)

