(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     67433,       1423]
NotebookOptionsPosition[     53482,       1148]
NotebookOutlinePosition[     61275,       1315]
CellTagsIndexPosition[     61196,       1310]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["", "SlideShowNavigationBar", "FirstSlide",
 CellMargins->{{0, 0}, {-1, 0}},
 CellTags->
  "SlideShowHeader",ExpressionUUID->"ae861ed8-5fa1-4088-84fd-2651cc7b368a"],

Cell["Extending the FrontEnd with LibraryLink", "Title",
 CellChangeTimes->{{3.875224639639944*^9, 
  3.8752246453280687`*^9}},ExpressionUUID->"8b1642a0-c2f2-4832-b962-\
da68c26a4047"],

Cell["\<\
Christopher Cole
Wolfram Research, Inc.\
\>", "Subtitle",
 CellChangeTimes->{{3.8303528001076193`*^9, 3.830352822403953*^9}, {
  3.8752246472739773`*^9, 3.875224659232708*^9}, {3.8752278931819897`*^9, 
  3.875227897773322*^9}},ExpressionUUID->"75c0d664-a0db-4889-a1b0-\
650f7c83e5d8"],

Cell[TextData[{
 "\n",
 Cell[BoxData[
  RowBox[{
   AdjustmentBox[
    TemplateBox[{
      GraphicsBox[{{
         GrayLevel[1], 
         FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
          0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 
          3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
          0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJBKJ3BkN/I8lTVIVMpp6LqqLrDC/lL+fHsH+1h/Alx
mqcFjj+A8xm+lT6YI7jVPreiaqnOYzU4P/KU0ZGN51Th/BvaqZKPIj7Yw/gP
3syz0blyzx5mHsO9rS01Fxbbw+yD8WHugfFr1m1Lqv+pBue/PmCp7HVb3QFm
HowPsw/Gh7kHxoe5F2YezD/o/kflqznYVkasMM1Vg/Mh5qk56DnLvH4UhuCj
2qeG5h41hwKQvN4Le5h5D2K9T7DbPoT7F8aHhQeMX6D9bfrdyS/h/AP7+OYY
L3pkDzMPxofZB+PD3APjw9wLMw/mH9T4VsPwPwBKz/oj
          "]]}, {
         Thickness[0.08333333333333333], 
         FaceForm[{
           RGBColor[1., 1., 1.], 
           Opacity[1.]}], 
         FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
          3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
          3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
          3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
          0}, {1, 3, 3}, {1, 3, 3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIvIGYC4uZAz7kNz5Qcpv+fUPf7l4LDaaMjG/XWKTsI
idgfu1Oq6HCVM0Mpx0LF4RRIXE/JYdE1k/cWrSoOC0E0qzJc/baWmgubZyo5
wMx7uX0983MfJYd1N+LL/OWU4Pph5jZB1a1ZC1TQr+CQt5hxD2uQsoP+f8W/
377KwfkqGnU9O1/LwPkR0Rv3v5GThpjzVcnhhezyFx7rJB2ivu681WWr5FD+
YI7gUlsJiPtaFR32HRRXC24Vd7AuONdxaZ4CnJ/D+XNBurE8nH8pP5793Ew5
h7tuzBXcS8QdwsH2yDn8Of3u5OFD4g53wOKyUHlBh99gcVmHjKvPs7S/cTj4
y4ll+RorONQ16/ss42J0cHUv+sm/UslBosfrFYvJf3uwP/mVHFb4OQgnHv5r
Dw6nNEU4HxxeZxTgfD1oOOzqZfsg5sEIDwceN9VSplmsDlNSO5JjY6Sh9jM5
bH5VvFW0WtrBoTJihelZBgf+KrPVdtel4eZ19T35JB8kA+fvBftbyqEt6vKe
xyIMDhD7JBw2bEuqv2nLBA+XG0KfHM+nsUDDSwzqHnao/aIOErInn9ov4XKw
uHY014RB1OHRy6mbeAo5HaQCb0nXPBSBmscBDS8RqPvY4HyYf2B8MbB5LHD+
LA7peXGaLHDzJhmW6yrKszqsFL7gcqNAGG4eJL6EHJbd38c3x5jToWG7Q9Mj
d0EHj4A/EsXXuR0g/hdw0DktcHzXDj4HuS85YbXr+B1UweEq4LCm+3YGQz6/
A1N+I8vRfh6HM9Z+FyfGcEP5bA5LoObC4hPG3/On/cvt67/h/Ihpin2lhT/h
/CcR4tsvMvywh5jPCbWfySFIfUHnhocsDrfA4cvloAUVX2Cjc2VWmiCcfxmc
LkXh/FVgf0vC9T8Hp38ZuPvA+ZNVweHb9LuT21t5ofkXlg8EHWRfPzKTYlCC
pmcRh+tA5a7HlaDhLe5wIFrB8aOyMjQ+peF8SHzLwfmQ8JR34LCdHTr/tTI8
/cPKh4qqpTrOdxSg9qk6GM7Ukpg6RdHhS19wiUq4ikPKmVjvE+6KkPJhHrT8
kFR0QC+PAPZc+cE=
          "]]}}, {
       ImageSize -> 0.027 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]}], 
      TemplateBox[{6}, "Spacer1"], 
      GraphicsBox[{{
         GrayLevel[1], 
         FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
          0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 
          3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
          0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJBKJ3BkN/I8lTVIVMpp6LqqLrDC/lL+fHsH+1h/Alx
mqcFjj+A8xm+lT6YI7jVPreiaqnOYzU4P/KU0ZGN51Th/BvaqZKPIj7Yw/gP
3syz0blyzx5mHsO9rS01Fxbbw+yD8WHugfFr1m1Lqv+pBue/PmCp7HVb3QFm
HowPsw/Gh7kHxoe5F2YezD/o/kflqznYVkasMM1Vg/Mh5qk56DnLvH4UhuCj
2qeG5h41hwKQvN4Le5h5D2K9T7DbPoT7F8aHhQeMX6D9bfrdyS/h/AP7+OYY
L3pkDzMPxofZB+PD3APjw9wLMw/mH9T4VsPwPwBKz/oj
          "]]}, {
         Thickness[0.08333333333333333], 
         FaceForm[{
           RGBColor[1., 1., 1.], 
           Opacity[1.]}], 
         FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
          0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
          3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 
          3}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGJxIGYC4ksM95g4uaQc9P8r/v32VdohkyG/kYVVAQdf
1AFVPYLfFnV5z2MRBihfBIMPU7+EcQ+rkAgPDr40mnoEf8ur4q2i1XJwfq/G
W959BQoOXfLJ76IOQfkfFB1+x+Qe/Wck5pByJtb7xHElqLy4w5q1N+LL+pUd
wt/o71bvl3SY8X9C3e9fyg7zz646f/WaNJwP8y92vgKaepj9UnA+LDysC851
XJqH4BvO1JKYKqLgAAA6xp7+
          "]]}}, {
       ImageSize -> 0.027 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]}], 
      TemplateBox[{6}, "Spacer1"], 
      GraphicsBox[{
        Thickness[0.08333333333333333], 
        FaceForm[{
          RGBColor[1., 1., 1.], 
          Opacity[1.]}], 
        FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 3}}, {{0, 2, 
          0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
          0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
          3}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{4.02, 8.7598}, {4.02, 
          8.3398}, {3.6899999999999995`, 8.0098}, {3.2399999999999998`, 
          8.0098}, {2.7899999999999996`, 8.0098}, {2.4899999999999993`, 
          8.3398}, {2.4899999999999993`, 8.7598}, {2.4899999999999993`, 
          9.1798}, {2.8199999999999994`, 9.5098}, {3.2399999999999998`, 
          9.5098}, {3.6599999999999997`, 9.5098}, {4.02, 9.1498}, {4.02, 
          8.7598}}, CompressedData["
1:eJxTTMoPSmViYGCQAGIQ3fo6cIccq7JD1VIdZ5nXzA4QvgIGP2dW+ZxFi0Xg
fF/RHq9XLeIO3zRi+g99lXOYf3bV+avXJBy4ri8usOWShfOrRNa5P6yShvNb
QPpbpRyerVN90iwHUy/lEP5Gf7d6vxicD7MfwhfB4J/QtJp0+r+sA9AwoIkS
cD7YOhFJh0sM95g4geYYgwGCnwYGUg77gqYp9n2VdgAaBjRRxkFvwoIfhmkw
/fJwPtBzQB8qwPkQ/YoOU76xxc84IwOR51dyUNn5p/1LtLQDODhWKDlsrv60
IeC1pAMsfCHuE4fz2UwEzWxsRR0AMJ+b7g==
          "], {{3.9899999999999998`, 2.4898}, {2.4899999999999993`, 2.4898}, {
          2.4899999999999993`, 7.4998}, {3.9899999999999998`, 7.4998}}}], 
        FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
         0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}}, {{1, 4, 3}, {0, 1, 0}, {1, 3, 
         3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
         0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgAmJBKJ3BkN/I8lTVIVMpp6LqqLrDC/lL+fHsH+1h/Alx
mqcFjj+A8xm+lT6YI7jVPreiaqnOYzU4P/KU0ZGN51Th/BvaqZKPIj7Yw/gP
3syz0blyzx5mHsO9rS01Fxbbw+yD8WHugfFr1m1Lqv+pBue/PmCp7HVb3QFm
HowPsw/Gh7kHxoe5F2YezD/o/kflqznYVkasMM1Vg/Mh5qk56DnLvH4UhuCj
2qeG5h41hwKQvN4Le5h5D2K9T7DbPoT7F8aHhQeMX6D9bfrdyS/h/AP7+OYY
L3pkDzMPxofZB+PD3APjw9wLMw/mH9T4VsPwPwBKz/oj
         "]]}, {
       AspectRatio -> Automatic, ImageSize -> 
        0.027 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}], 
        PlotRange -> {{0., 12.}, {0., 12.}}}]},
     "RowDefault"],
    BoxBaselineShift->-0.3416543244041976,
    BoxMargins->{{0., 0.}, {0.3416543244041976, -0.3416543244041976}}], 
   " "}]],ExpressionUUID->"376f2a73-bc68-4fdb-b608-b3b1705e8eb8"],
 " #WolframTechConf"
}], "Subtitle",
 CellMargins->{{0, 0}, {20, -10}},
 CellChangeTimes->{3.78802031357596*^9},
 FontSize->0.025 
  FrontEnd`AbsoluteCurrentValue[{
    WindowSize, 1}],ExpressionUUID->"82304148-2048-4796-ab46-715a0d811c28"]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"ee3ea2a1-973b-4e9a-a704-0d8a3c30d1be"],

Cell[CellGroupData[{

Cell["ABSTRACT", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.7257199329223537`*^9, 3.725720005948655*^9}, {
   3.72572008110417*^9, 3.725720088583918*^9}, {3.735906066467186*^9, 
   3.7359060766280823`*^9}, 3.7880100304206944`*^9, {3.788018566457625*^9, 
   3.788018567874702*^9}, {3.7880186005884113`*^9, 
   3.788018634852206*^9}},ExpressionUUID->"75e785bd-e551-42c4-b918-\
1ff722dfcee0"],

Cell["\<\
The FrontEnd supports a subset of the Kernel\[CloseCurlyQuote]s LibraryLink \
interface allowing it to load dynamic libraries (dll, so, and dylib) and \
invoke functions that conform to the LibraryLink standards.  This allows the \
FrontEnd to access these libraries directly without passing through the \
Kernel, improving efficiency for libraries whose primary use is as a part of \
the user interface.  In this talk, you will learn how to access the FrontEnd\
\[CloseCurlyQuote]s LibraryLink evaluator and the benefits and restrictions \
of the evaluator. \
\>", "Text",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.725720132418301*^9, 3.7257201347705364`*^9}, 
   3.788018628487426*^9, 
   3.8752247373193703`*^9},ExpressionUUID->"932e9e57-52c9-4a85-ac72-\
ea4c898bd4bb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"4e8e5a7c-8b4e-47e7-a75d-3cb2b655ed51"],

Cell[CellGroupData[{

Cell["The FrontEnd\[CloseCurlyQuote]s Expression Evaluator", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.483202458955147*^9, {3.514308340990994*^9, 3.514308352103572*^9}, 
   3.7880179920575123`*^9, {3.8752248134170227`*^9, 
   3.875224823253777*^9}},ExpressionUUID->"bf6b684b-be70-47c1-be5a-\
c3838a1d25c9"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnU2OI72yno9tkvDQKq3AG5DUM089dH09uoYXcC98ffvrwTFwrgHDc5V2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    "], {{0, 84.}, {254., 0}}, {0, 255},
    ColorFunction->RGBColor,
    ImageResolution->{144, 144}],
   BoxForm`ImageTag["Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJyVVwdYU8kWnltSIbQAAlJCb4KIlABSQmgBpIQm2EgjhBJiQlCxl0UF1y4W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      "], "RGB", "XYZ"], Interleaving -> True, 
    MetaInformation -> <|"XMP" -> <||>|>],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->{642.8203125, Automatic},
  ImageSizeRaw->{254., 84.},
  PlotRange->{{0, 254.}, {0, 84.}}]], "Input",
 TextAlignment->Center,ExpressionUUID->"bb712ecf-e8fd-432f-ba51-c40886250e8a"],

Cell["\<\
The FrontEnd has its own Wolfram Language (WL) expression evaluator.\
\>", "Text",
 CellChangeTimes->{{3.875230602722536*^9, 
  3.875230603933321*^9}},ExpressionUUID->"2d349334-a607-4342-adff-\
13eaa869a12f"],

Cell["\<\
The main purpose is to reduce interprocess communication (IPC) overhead so \
that notebook user interfaces are efficient and responsive.\
\>", "Text",
 CellChangeTimes->{
  3.875230615546571*^9, {3.8752693508922873`*^9, 
   3.8752693538187428`*^9}},ExpressionUUID->"701504ec-96af-4b71-a9b9-\
3143f313e37c"],

Cell["\<\
It also provides a convenient WL access point to features that the FrontEnd \
is specifically responsible for such as measuring string metrics.\
\>", "Text",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.495209008234375*^9, 3.49520915653125*^9}, 
   3.495209919765625*^9, 3.4952106014375*^9, {3.4952106824375*^9, 
   3.495210832234375*^9}, 3.514307848543872*^9, {3.514308058576482*^9, 
   3.514308065607885*^9}, {3.51430841745117*^9, 3.514308419642997*^9}, {
   3.5149152616687326`*^9, 3.514915280523456*^9}, {3.514915328702818*^9, 
   3.5149153375415287`*^9}, 3.514915444638068*^9, 3.78801854468054*^9, {
   3.875224852185698*^9, 3.875224955656487*^9}, {3.875225033643299*^9, 
   3.875225094871908*^9}, {3.875225651944231*^9, 3.875225674176435*^9}, {
   3.875230599068074*^9, 3.8752306132162857`*^9}, {3.875270049118053*^9, 
   3.875270049512199*^9}},ExpressionUUID->"ad6ec621-e2d5-4417-b7ad-\
4f0729f69bd8"],

Cell[BoxData[
 RowBox[{"FE`Evaluate", "[", 
  RowBox[{"FEPrivate`StringWidth", "[", "\"\<Wolfram\>\"", "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.8752251308679323`*^9, 3.875225134639729*^9}, 
   3.875225216861332*^9, {3.875225398529066*^9, 3.875225483737919*^9}, {
   3.87522553984908*^9, 3.875225578294613*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"5caa8c11-59aa-4955-8a6e-307f051bd482"],

Cell[TextData[{
 "The FrontEnd evaluator is used to evaluate expressions that belong to UI \
constructs such as the ",
 Cell[BoxData[
  FormBox["ButtonFunction", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "ec004f13-49ea-43e9-bdce-bbbb20dc27ac"],
 " of a ",
 Cell[BoxData[
  FormBox["ButtonBox", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "54281b16-c8d3-4f48-9bce-5065eee6e757"],
 "."
}], "Text",
 CellChangeTimes->{{3.875225711236561*^9, 3.8752257464403343`*^9}, {
  3.875230632341164*^9, 
  3.8752306408299637`*^9}},ExpressionUUID->"5a055d9a-2da0-4c1a-b3af-\
ea7a96b4a4a6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"38b5505c-316b-48af-890a-be7518549a65"],

Cell[CellGroupData[{

Cell["FrontEnd Evaluator Limitations", "Section",
 CellChangeTimes->{{3.875230400697537*^9, 
  3.875230405459876*^9}},ExpressionUUID->"01ce1230-e742-459f-97f6-\
b2dde836e46e"],

Cell[TextData[{
 "The FrontEnd evaluator attempts to perform evaluations identically to how \
they would be evaluated in a Kernel, and if this cannot be guaranteed, it \
does not complete the evaluation. The FrontEnd can barely perform very simple \
addition; ",
 Cell[BoxData[
  FormBox["Plot", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "c47b32e0-0748-4186-9808-d62e104f2ba4"],
 " or ",
 Cell[BoxData[
  FormBox["NDSolve", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "791e5359-e49e-47d7-b75a-2cf32907dffc"],
 " are right out."
}], "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.875269400938611*^9, 3.875269488960287*^9}, {
  3.875269540366913*^9, 
  3.8752695877425337`*^9}},ExpressionUUID->"b4d08552-959f-4dd0-8e8b-\
e009589c1cc5"],

Cell["\<\
If the FrontEnd evaluator cannot complete an evaluation, it will use an \
available Kernel if possible.\
\>", "Text",
 CellChangeTimes->{{3.875225759110016*^9, 3.87522588776337*^9}, {
  3.875269373227084*^9, 3.875269385963087*^9}, {3.875270154420312*^9, 
  3.875270162231525*^9}},ExpressionUUID->"5ab0e818-5e3a-4d98-b051-\
04c411682e12"],

Cell["\<\
The FrontEnd evaluator doesn\[CloseCurlyQuote]t directly support first-class \
functions. If it doesn\[CloseCurlyQuote]t know how to handle an expression \
with a specific head, it has to go to a Kernel or leave it unevaluated.\
\>", "Text",
 CellChangeTimes->{{3.875226041238546*^9, 3.8752261578764343`*^9}, {
  3.875230502525186*^9, 3.875230530200091*^9}, {3.875269600270656*^9, 
  3.875269606717144*^9}},ExpressionUUID->"c4c74716-52c6-441f-b5c2-\
d12a06ee316f"],

Cell[TextData[{
 "Where the FrontEnd has partial support of a Kernel function it uses a \
special context, ",
 Cell[BoxData[
  FormBox["FEPrivate`", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "443cff5b-8cc9-48e6-8f48-ea1a8bde8fbf"],
 ", to indicate to the evaluator that we \[OpenCurlyDoubleQuote]accept the \
risks\[CloseCurlyDoubleQuote] and want the evaluation to remain in the \
FrontEnd."
}], "Text",
 CellChangeTimes->{{3.8752259271961327`*^9, 3.8752259712641277`*^9}, {
  3.8752261745833597`*^9, 3.8752261966850443`*^9}, {3.875230549354397*^9, 
  3.8752305545432653`*^9}, {3.875269638845064*^9, 
  3.875269720986216*^9}},ExpressionUUID->"15324f3c-7c7a-41d7-839d-\
77534fa356ad"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellChangeTimes->{{3.875230393388266*^9, 3.875230393388275*^9}},
 CellTags->
  "SlideShowHeader",ExpressionUUID->"9d849a47-dc4c-4960-a2b3-5251a445cca8"],

Cell[CellGroupData[{

Cell["Example: Buttons that do not call the Kernel", "Section",
 CellChangeTimes->{{3.875227085716062*^9, 
  3.875227119044157*^9}},ExpressionUUID->"f1273ee5-3ee3-4a14-b492-\
85568a939dea"],

Cell["\<\
The Button changes the color of the cell containing it based on the state of \
the shift key.\
\>", "Text",
 CellChangeTimes->{{3.875279829828414*^9, 
  3.8752798557381363`*^9}},ExpressionUUID->"7c5c09f7-0667-40e5-aa45-\
f04524b0283c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"876955d7-7c08-4a9b-b335-e62f32462524"],

Cell[CellGroupData[{

Cell["LibraryLink", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.483202458955147*^9, {3.51430857274755*^9, 3.514308578875259*^9}, 
   3.788018000921266*^9, 3.788019441530291*^9, {3.875226219019704*^9, 
   3.875226220508644*^9}},ExpressionUUID->"22fb02b5-cbc0-4b90-9450-\
204f41a870fc"],

Cell["LibraryLink is a Kernel feature that", "Text",
 CellChangeTimes->{{3.875226243128174*^9, 
  3.8752262484097443`*^9}},ExpressionUUID->"20357dc6-0c0e-4524-ae71-\
c879271561a8"],

Cell["\<\
provides a WL API for loading dynamic libraries and calling functions from \
that library at evaluation time\
\>", "Item",
 CellChangeTimes->{{3.875226262408638*^9, 
  3.875226304726173*^9}},ExpressionUUID->"c4da5934-8c94-49a4-b640-\
305859be84ef"],

Cell["\<\
a protocol and calling convention for C-language functions allowing them to \
be called from WL evaluated in a Kernel\
\>", "Item",
 CellChangeTimes->{{3.875226262408638*^9, 
  3.8752263495989933`*^9}},ExpressionUUID->"9f4a8172-c7b5-4450-8803-\
a5235d7a127e"],

Cell["\<\
This provides a modular method to load dynamic libraries in a running Kernel, \
extending its capabilities.\
\>", "Text",
 CellChangeTimes->{{3.87522635714437*^9, 
  3.875226437704493*^9}},ExpressionUUID->"02191da3-427b-41b0-9042-\
ca3fa55a2816"],

Cell["\<\
Examples of dynamic libraries used in the Kernel are FFmpeg through the \
FFmpegTools paclet to support video and audio processing and libgit2 through \
gitlink to support source code management in WL.\
\>", "Text",
 CellChangeTimes->{{3.8752264399613132`*^9, 3.875226457310528*^9}, {
  3.87522648988518*^9, 
  3.8752265625532513`*^9}},ExpressionUUID->"a8480774-2e07-4c1b-8e43-\
8651f16e80bc"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"d0653087-e6fc-4117-98fa-618b3d35e3ba"],

Cell[CellGroupData[{

Cell["LibraryLink in the FrontEnd", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.483202458955147*^9, {3.514308863196991*^9, 3.5143088633311243`*^9}, 
   3.788013415920067*^9, {3.875226589654833*^9, 
   3.8752265943511047`*^9}},ExpressionUUID->"748d284b-6ee0-4ac7-9756-\
ff29a9b02b30"],

Cell["\<\
The FrontEnd supports many of the Kernel\[CloseCurlyQuote]s access points to \
LibraryLink and a subset of its features. In particular, the FrontEnd can \
load exactly the same libraries as the Kernel, meaning they do not need to be \
rebuilt to be used by the different processes.\
\>", "Text",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.514308661619236*^9, 3.514308664754455*^9}, 
   3.78801341354379*^9, {3.875226605717503*^9, 3.875226631154202*^9}, {
   3.8752712244478188`*^9, 
   3.87527126382651*^9}},ExpressionUUID->"c0760fec-2c98-4e68-bfc9-\
10fb8c0c6fad"],

Cell[BoxData[GridBox[{
   {Cell["Load any dynamic library",ExpressionUUID->
     "1ddd7810-5ed2-4948-80f9-1eaaf5b6629d"]},
   {Cell["Support for MArgument calling convention",ExpressionUUID->
     "966920ad-63bf-4a7d-966e-76469df810e1"]},
   {Cell["Support for MLINK calling convention",ExpressionUUID->
     "101694dc-8eaa-48c9-80d7-906ef2fce546"]},
   {Cell["LibraryLink memory managment modes (\"Shared\" not supported)",
     ExpressionUUID->"857c9330-3b87-42b7-8eb1-ec28c3911e2b"]},
   {Cell["Scalar types: Integer, Real, String (Complex not supported)",
     ExpressionUUID->"31edd12c-da4e-47fe-bc49-3eaba7ddaeae"]},
   {Cell["MTensor (coming soon)",ExpressionUUID->
     "7b2f5b6d-be99-431c-bd26-9c25e28b15ad"]},
   {Cell["MNumericArray (type conversion not supported)",ExpressionUUID->
     "9d004735-078b-4bd2-a51c-a9670c5f0580"]},
   {Cell["MSparseArray",ExpressionUUID->
     "ac1be4b7-a9c7-4c45-a585-dbae5fef7a99"]},
   {Cell["MImage",ExpressionUUID->"beb4d0a4-ef96-4f23-b9fc-1bd38859e824"]},
   {Cell["Library Expression Manager",ExpressionUUID->
     "9da810d1-31ed-4404-95d3-f604e8f4f0a4"]},
   {Cell["Library Callback Manager",ExpressionUUID->
     "2a1eea87-3479-4c3b-9ae8-597b75ca0b74"]},
   {Cell["Wolfram Compile Library",ExpressionUUID->
     "9ff98a3f-d95c-443c-9e25-46f268940f93"]}
  },
  GridBoxBackground->{"Columns" -> {{None}}, "Rows" -> {
      RGBColor[0, 1, 0], 
      RGBColor[0, 1, 0], 
      RGBColor[0, 1, 0], 
      RGBColor[1, 1, 0], 
      RGBColor[1, 1, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 1, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 0, 0], 
      RGBColor[1, 0, 0]}},
  GridBoxDividers->{
   "Columns" -> {True, {False}, True}, 
    "Rows" -> {True, {True}, True}}]], "Input",
 CellChangeTimes->{{3.875228928252812*^9, 3.875228929254187*^9}, {
  3.8752294080004787`*^9, 
  3.8752296289017277`*^9}},ExpressionUUID->"f70bd1bf-3410-4669-bdc1-\
e6dd2d18f852"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"1aee3a95-fbc0-498b-abd0-c921a035505b"],

Cell[CellGroupData[{

Cell["Calling Differences between FrontEnd and Kernel", "Section",
 CellChangeTimes->{{3.8752269443405657`*^9, 
  3.87522695456912*^9}},ExpressionUUID->"05e7ef2d-d584-4f5c-8df1-\
474e57694088"],

Cell[BoxData[GridBox[{
   {Cell["Kernel",ExpressionUUID->"4700021f-3a7d-4dfa-8201-a5cca4ac351e"], 
    Cell["FrontEnd",ExpressionUUID->"97356a13-26b9-402e-b8cf-9d6714f22997"]},
   {Cell["$LibraryPath",ExpressionUUID->
     "90211420-6609-44c7-9655-24f0e221db77"], Cell[
    "FEPrivate`$LibraryPath",ExpressionUUID->
     "76429523-7f94-46ad-9ea4-0f8f5fd2750f"]},
   {Cell["LibraryLoad",ExpressionUUID->
     "a35baf13-4db4-4ee6-95a0-67ad2cae3cbd"], Cell[
    "FEPrivate`LibraryLoad",ExpressionUUID->
     "84b5b762-0036-40da-ab6e-79a125f64173"]},
   {Cell["LibraryUnload",ExpressionUUID->
     "8ba58985-bd72-4d69-8350-743eb81cb53c"], Cell[
    "FEPrivate`LibraryFunctionUnload",ExpressionUUID->
     "1bd71c88-79c0-46e4-b18e-3394bcba155b"]},
   {Cell["LibraryFunctionLoad",ExpressionUUID->
     "f8b0b286-8c2d-4d5c-90ef-8a182681c93c"], Cell[
    "FEPrivate`LibraryFunctionLoad",ExpressionUUID->
     "39cfb3f9-7470-4df0-b447-5da0dc2f379d"]},
   {Cell["LibraryFunctionUnload",ExpressionUUID->
     "fcc0b987-738e-4429-bc57-a4ba125d9dca"], Cell[
    "FEPrivate`LibraryFunctionUnload",ExpressionUUID->
     "a0b1ec1f-bb1e-4cf7-8624-f7d8c765995d"]},
   {Cell["LibraryFunctionInformation",ExpressionUUID->
     "29273bac-2b16-4690-bd6a-527bd6fea027"], Cell[
    "FEPrivate`LibraryFunctionInformation",ExpressionUUID->
     "b5713f62-0423-4a68-9075-0fdb62922a9f"]},
   {Cell["FindLibrary",ExpressionUUID->
     "1238ccdd-b7b4-4eb9-bad3-705ef6487100"], Cell[
    "FEPrivate`FindLibrary",ExpressionUUID->
     "80453141-49cf-4815-bd70-4e4b3b5932c9"]},
   {Cell["(not needed)",ExpressionUUID->
     "ff18736b-2f5f-4c20-bc2f-191a229bb476"], Cell[
    "FEPrivate`LibraryFunctionApply",ExpressionUUID->
     "e139ce9a-63e4-41f4-a6ff-ded682b4e1af"]},
   {Cell["(no direct equivalent)",ExpressionUUID->
     "fdc03a6b-86fc-49ef-a8fe-b4c86125957a"], Cell[
    "FEPrivate`ManagedLibraryInformation",ExpressionUUID->
     "83a1f1a0-2b30-4e9c-806f-0638bcb45570"]}
  },
  GridBoxBackground->{"Columns" -> {{None}}, "Rows" -> {
      RGBColor[0.8, 0.8, 1]}},
  GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}}]], "Input",
 CellChangeTimes->{{3.875229923359178*^9, 3.875229978130375*^9}, {
  3.8752300294495993`*^9, 3.875230255397709*^9}, {3.875269104012196*^9, 
  3.875269104664958*^9}},
 FontWeight->"Bold",ExpressionUUID->"92ad768a-2028-4c6e-8b36-5beca18aac5a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"49daebd4-e7c9-47c2-82bb-31039aa26db5"],

Cell[CellGroupData[{

Cell["Example: Buttons using LibraryLink", "Section",
 CellChangeTimes->{{3.875226997505752*^9, 3.8752270046859283`*^9}, {
  3.875227136991016*^9, 
  3.875227148035994*^9}},ExpressionUUID->"74215396-e667-45fd-a769-\
795ec7ca0f26"],

Cell[TextData[{
 "The LibraryLink dynamic library provides an interface to the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"stat", "(", ")"}], TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "247f236f-aabc-4dfc-95dd-a1ea3d2c1665"],
 " POSIX function. The Buttons access the library to update the ",
 Cell[BoxData[
  FormBox["CellTag", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "06fee4b0-f21a-408c-9d94-09ff7ca3ce7d"],
 " in the cell which contains the button."
}], "Text",
 CellChangeTimes->{{3.87527987096807*^9, 3.87527994893266*^9}, {
  3.875280190485899*^9, 
  3.8752801933285627`*^9}},ExpressionUUID->"7fba4c40-815f-4f03-8617-\
094c7c6b96bf"],

Cell["\<\
When debugging a LibraryLink library for the FrontEnd, it\[CloseCurlyQuote]s \
a good idea to test it in the Kernel, first, so that if (when) the library \
crashes, it doesn\[CloseCurlyQuote]t bring down your whole development \
environment.\
\>", "Text",
 CellChangeTimes->{{3.875280198610269*^9, 
  3.875280248128104*^9}},ExpressionUUID->"164f0dec-913b-41a3-ab6b-\
ac10ee061bfd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"3b5189f8-608c-47e2-b609-5d995e10fb40"],

Cell[CellGroupData[{

Cell["Example: Video Player", "Section",
 CellChangeTimes->{{3.8752271690095463`*^9, 
  3.8752271787636538`*^9}},ExpressionUUID->"a7743bc4-b8ab-4780-8f41-\
67555bfb2770"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Video", "[", "\"\<ExampleData/Caminandes.mp4\>\"", "]"}]], "Input",
 CellLabel->"In[15]:=",ExpressionUUID->"d904ae87-bd19-48a9-8df5-be127aba5a59"],

Cell[BoxData[
 TemplateBox[<|"opts" -> Sequence[
     RowBox[{"AudioOutputDevice", "\[Rule]", "Automatic"}]], "resourcePath" -> 
   "ExampleData/Caminandes.mp4", "appearance" -> "Basic", "position" -> 0., 
   "currentVideoTrack" -> 1, "currentAudioTrack" -> 1, "currentSubtitleTrack" -> 
   0, "volume" -> 1, "audioDevice" -> Automatic, 
   "currentRasterSize" -> {738, 416}, "imageSizeOption" -> Automatic, 
   "cachedFrame" -> ByteArray[CompressedData["
1:eJxTTMoPSmJkYGBIFGNg+H/j/wMGAS83TzcGRkZGBg8gZPj/kOGKa0VmGgOD
p6cWAwdQJRAzcjKA9DxiAjKh7AVAQoqRFczOA2JpKLsMiDWgaoDKGQwZmRhM
gHQdEBsB2VJAehMQa3VA1Pz+//8/kAJZDebDaOei1MSS1BSF8sySDIWSjFSF
8PyctKLEXAWfxLz00sT0VAUrhfLycr1yiLBecn4ug5GBkZGVoYGVkYGCoaGV
obmVoYWugamVgQHD/9sMzgwcbGzsbKwc7OzsnJwcXDwivDzc3DySQsL8IrJS
8nKyUjIyCip66gpKOsoyMhrmmjoGhiYmJvLqlrYWRjZ6xiZGIEMYOTk5ebh5
JHh5JYwUZRSNSAb/DzAIcjAuYHrEzKjEwCTIyCzI+P8IgzzQ06yMYMAABYxM
zCysbOwcnFzcQAVbBRiYGJmZmViYWVlZWICytUB5BhZBViFFQ0c24cBEdqVC
EaPGiQs5lJ02HhQNuvhBxTipqImTS0xcQlJKVU1dQ1PLxNTM3MLSytnF1c3d
w9MrOCQ0LDwiMio5JTUtPSMzq7iktKy8orKquaW1rb2js2vS5ClTp02fMXPW
osVLli5bvmLlqk2bt2zdtn3Hzl2HDh85euz4iZOnLl2+cvXa9Rs3bz189PjJ
02fPX7x89fHT5y9fv33/8fMXyF+MDMyMMIDVX4JAfzGxsDCzsIP8xchUDlIg
yMKqaMgm5BjInlgorGTUyCHiNHHhxoOcysZBH0STii5yiamYPFT9CPIa2GfE
eayJLJ/BPYbw1y0GHmZGYOQxCzLYM/z816WxgGkUj+JRPIpH8SgexaN4FI/i
UTyKR/EoHsWjeBSP4hGG+f/fBAAchE9i
     "]], 
   "properties" -> <|
    "duration" -> 90.023, 
     "trackDescriptors" -> <|
      "Video" -> {1 -> "Track 1"}, "Audio" -> {1 -> "Track 1"}, 
       "Subtitle" -> {}|>, "originalRasterSizes" -> {{852, 480}}, 
     "rasterSizeOption" -> Automatic, "fileSize" -> 6524641|>, "version" -> 2,
    "form" -> StandardForm|>,
  "VideoBox2",
  Editable->False,
  Selectable->False]], "Output",
 CellChangeTimes->{3.875271438899543*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"246525a2-9768-4851-8c6a-b2dcd064bf1e"]
}, Open  ]],

Cell["\<\
The video player in Mathematica 13.1 uses LibraryLink in the FrontEnd to \
reduce IPC and eliminate several instances of memory copies relative to a \
similar implementation in the Kernel. The video player library launches a \
thread from the FrontEnd to act as a worker, decoding frames and placing them \
in a specific memory block. The FrontEnd invokes another LibraryLink function \
to update a RasterBox with new frames after they are written to the memory \
block.\
\>", "Text",
 CellChangeTimes->{{3.8752274612858047`*^9, 3.875227526445674*^9}, {
   3.875227556899934*^9, 3.875227657349226*^9}, 3.875231400693816*^9, {
   3.875268848424726*^9, 3.87526905172536*^9}, {3.8752709284255943`*^9, 
   3.875270946223054*^9}},
 FontSize->Dynamic[
  0.020000000000000007` 
   FrontEnd`AbsoluteCurrentValue[{
     WindowSize, 1}]],ExpressionUUID->"7fa708c2-8646-4798-9621-3325c3ffcd7b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"3dd70ad0-b846-4c51-8188-c3ca533c31be"],

Cell[CellGroupData[{

Cell["Acknowledgements", "Section",
 CellChangeTimes->{{3.875227195344298*^9, 
  3.875227203964879*^9}},ExpressionUUID->"5f0aa436-2c14-4579-8da5-\
501f76cd57db"],

Cell["\<\
I want to thank John Fultz and Lou D`Andria for technical discussions \
preparing examples for this talk.\
\>", "Text",
 CellChangeTimes->{{3.875227228684227*^9, 
  3.8752273157815647`*^9}},ExpressionUUID->"7c8ee2de-beef-4871-82aa-\
d31f0bd43f3a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->
  "SlideShowHeader",ExpressionUUID->"347492f0-43b8-4a6f-9147-e2131bc5585a"],

Cell["Questions", "Section",
 CellChangeTimes->{{3.875272163158128*^9, 
  3.875272163770165*^9}},ExpressionUUID->"59086f0b-6f7c-453d-a2bd-\
1fd4ab461bbd"]
}, Open  ]]
},
ScreenStyleEnvironment->"Slideshow Working",
WindowSize->{1185, 812},
WindowMargins->{{Automatic, 125}, {Automatic, -997}},
TaggingRules->{
 "PresenterSettings" -> {
   "ShowNavigationBar" -> False, 
    "SlideBreakStyles" -> {"Title", "Chapter", "Section"}, "ShowSlideBreaks" -> 
    True, "Theme" -> {
     "ThemeName" -> "Facet", "FontSetName" -> "Facet", "ColorSetName" -> 
      "Default"}, "WindowSize" -> {1185, 812}, 
    "WindowMargins" -> {{190, 353}, {5, 193}}, 
    "UserModifications" -> {{"Text", FontSize -> 23.70000000000001}, {
      "Input", TextAlignment -> Center}, {
      "InheritFromParent", FontWeight -> "Bold"}}, "Dialogs" -> {}}},
FrontEndVersion->"13.1 for Mac OS X ARM (64-bit) (June 16, 2022)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"PresenterTools"}, "Facet.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Notebook"], 
    StyleHints -> {
     ParentList, "CodeFont" -> "Source Code Pro", 
      "ColorSet" -> {
       "Display1" -> RGBColor[0.866667, 0.0666667, 0], "Display2" -> 
        RGBColor[0.67, 0.0666667, 0], "Display3" -> 
        RGBColor[0.67, 0.0666667, 0], "Text1" -> GrayLevel[0.1], "Text2" -> 
        GrayLevel[1], "Text3" -> GrayLevel[0], "Text1Reverse" -> 
        GrayLevel[0.75], "Text2Reverse" -> GrayLevel[0.75], "Text3Reverse" -> 
        GrayLevel[0.75], "Dingbat" -> RGBColor[0.866667, 0.0666667, 0], 
        "Default" -> GrayLevel[0.1], "Background" -> GrayLevel[1]}, 
      "FontSet" -> {
       "Display1" -> "Source Sans Pro", "Display2" -> "Source Sans Pro", 
        "Display3" -> "Source Sans Pro", "Text1" -> "Source Sans Pro", 
        "Text2" -> "Source Sans Pro", "Text3" -> "Source Sans Pro", "Dingbat" -> 
        "Source Sans Pro", "Default" -> "Source Sans Pro"}, 
      "SlideBreakStyles" -> {}}], 
   Cell[
    StyleData["FirstSlide"], 
    PrivateCellOptions -> {
     "PagewiseNotebookBaseStyle" -> {
       BackgroundAppearance -> 
        FrontEnd`FileName[{"PresenterTools"}, 
          "Background-Facet-Default.png"]}}], 
   Cell[
    StyleData["Title"], FontSize -> 36, FontWeight -> "Bold", FontTracking -> 
    "Plain", FontVariations -> {"CapsType" -> "Normal"}], 
   Cell[
    CellGroupData[{
      Cell["Section", "Subsection"], 
      Cell[
       StyleData["Section"], FontTracking -> "Plain", 
       FontVariations -> {"CapsType" -> "Normal"}], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsection"], FontTracking -> "Plain", 
          FontVariations -> {"CapsType" -> "Normal"}], 
         Cell[
          StyleData["Subsection", "Slideshow Working"], FontSize -> 
          Dynamic[0.029 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]]], 
         Cell[
          StyleData["Subsection", "Slideshow Presentation"], FontSize -> 
          Dynamic[0.029 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]]]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsubsection"], FontTracking -> "Plain", 
          FontVariations -> {"CapsType" -> "Normal"}], 
         Cell[
          StyleData["Subsubsection", "Slideshow Working"], FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]], 
          FontWeight -> "DemiBold"], 
         Cell[
          StyleData["Subsubsection", "Slideshow Presentation"], FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]], 
          FontWeight -> "DemiBold"], 
         Cell[
          StyleData["Subsubsubsection", "Slideshow Working"], FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]], 
          FontWeight -> "DemiBold", FontTracking -> "Plain"], 
         Cell[
          StyleData["Subsubsubsection", "Slideshow Presentation"], FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]], 
          FontWeight -> "DemiBold", FontTracking -> "Plain"], 
         Cell[
          StyleData["Subsubsubsubsection", "Slideshow Working"], FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]]], 
         Cell[
          StyleData["Subsubsubsubsection", "Slideshow Presentation"], 
          FontSize -> 
          Dynamic[0.026 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]]]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["InputOnly"], FontSize -> 13], 
         Cell[
          StyleData["InputOnly", "SlideShow"], 
          CellMargins -> {{100, 10}, {8, 15}}], 
         Cell[
          StyleData["InputOnly", "Slideshow Working"], CellMargins -> 
          Dynamic[{{
             0.135 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}], 0.03 
              FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]}, {
             0.00992593 FrontEnd`AbsoluteCurrentValue[{WindowSize, 2}], 
              0.0186111 FrontEnd`AbsoluteCurrentValue[{WindowSize, 2}]}}], 
          LinebreakAdjustments -> {1, 2., 12., 1., 1.}, FontSize -> 
          Dynamic[0.019 FrontEnd`AbsoluteCurrentValue[{WindowSize, 1}]]], 
         Cell[
          StyleData[
          "InputOnly", "Slideshow Presentation", StyleDefinitions -> 
           StyleData["InputOnly", "Slideshow Working"]]], 
         Cell[
          StyleData[
          "InputOnly", "Scrolling Presentation", StyleDefinitions -> 
           StyleData["InputOnly", "Slideshow Working"]]], 
         Cell[
          StyleData["InputOnly", "Printout"], 
          CellMargins -> {{49, Inherited}, {Inherited, Inherited}}, 
          LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Open]]}, Open]]}, 
  Visible -> False, FrontEndVersion -> 
  "13.1 for Mac OS X ARM (64-bit) (June 16, 2022)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"],
ExpressionUUID->"6badcf8e-de7f-41e8-a16c-83e2c316b3df"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "SlideShowHeader"->{
  Cell[580, 22, 169, 3, 58, "SlideShowNavigationBar",ExpressionUUID->"ae861ed8-5fa1-4088-84fd-2651cc7b368a",
   CellTags->"SlideShowHeader"],
  Cell[7788, 172, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"ee3ea2a1-973b-4e9a-a704-0d8a3c30d1be",
   CellTags->"SlideShowHeader"],
  Cell[9228, 209, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"4e8e5a7c-8b4e-47e7-a75d-3cb2b655ed51",
   CellTags->"SlideShowHeader"],
  Cell[36544, 695, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"38b5505c-316b-48af-890a-be7518549a65",
   CellTags->"SlideShowHeader"],
  Cell[39251, 768, 188, 3, 61, "SlideShowNavigationBar",ExpressionUUID->"9d849a47-dc4c-4960-a2b3-5251a445cca8",
   CellTags->"SlideShowHeader"],
  Cell[39950, 792, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"876955d7-7c08-4a9b-b335-e62f32462524",
   CellTags->"SlideShowHeader"],
  Cell[41852, 850, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"d0653087-e6fc-4117-98fa-618b3d35e3ba",
   CellTags->"SlideShowHeader"],
  Cell[44975, 930, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"1aee3a95-fbc0-498b-abd0-c921a035505b",
   CellTags->"SlideShowHeader"],
  Cell[47723, 993, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"49daebd4-e7c9-47c2-82bb-31039aa26db5",
   CellTags->"SlideShowHeader"],
  Cell[49235, 1038, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"3b5189f8-608c-47e2-b609-5d995e10fb40",
   CellTags->"SlideShowHeader"],
  Cell[52570, 1115, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"3dd70ad0-b846-4c51-8188-c3ca533c31be",
   CellTags->"SlideShowHeader"],
  Cell[53187, 1138, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"347492f0-43b8-4a6f-9147-e2131bc5585a",
   CellTags->"SlideShowHeader"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"SlideShowHeader", 59434, 1282}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 169, 3, 58, "SlideShowNavigationBar",ExpressionUUID->"ae861ed8-5fa1-4088-84fd-2651cc7b368a",
 CellTags->"SlideShowHeader"],
Cell[752, 27, 184, 3, 390, "Title",ExpressionUUID->"8b1642a0-c2f2-4832-b962-da68c26a4047"],
Cell[939, 32, 294, 7, 161, "Subtitle",ExpressionUUID->"75c0d664-a0db-4889-a1b0-650f7c83e5d8"],
Cell[1236, 41, 6515, 126, 138, "Subtitle",ExpressionUUID->"82304148-2048-4796-ab46-715a0d811c28"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7788, 172, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"ee3ea2a1-973b-4e9a-a704-0d8a3c30d1be",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[7935, 178, 429, 8, 119, "Section",ExpressionUUID->"75e785bd-e551-42c4-b918-1ff722dfcee0"],
Cell[8367, 188, 812, 15, 318, "Text",ExpressionUUID->"932e9e57-52c9-4a85-ac72-ea4c898bd4bb"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9228, 209, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"4e8e5a7c-8b4e-47e7-a75d-3cb2b655ed51",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[9375, 215, 349, 7, 119, "Section",ExpressionUUID->"bf6b684b-be70-47c1-be5a-c3838a1d25c9"],
Cell[9727, 224, 24253, 403, 236, "Input",ExpressionUUID->"bb712ecf-e8fd-432f-ba51-c40886250e8a"],
Cell[33983, 629, 218, 5, 60, "Text",ExpressionUUID->"2d349334-a607-4342-adff-13eaa869a12f"],
Cell[34204, 636, 316, 7, 103, "Text",ExpressionUUID->"701504ec-96af-4b71-a9b9-3143f313e37c"],
Cell[34523, 645, 945, 16, 103, "Text",ExpressionUUID->"ad6ec621-e2d5-4417-b7ad-4f0729f69bd8"],
Cell[35471, 663, 397, 7, 52, "Input",ExpressionUUID->"5caa8c11-59aa-4955-8a6e-307f051bd482"],
Cell[35871, 672, 624, 17, 103, "Text",ExpressionUUID->"5a055d9a-2da0-4c1a-b3af-ea7a96b4a4a6"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36544, 695, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"38b5505c-316b-48af-890a-be7518549a65",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[36691, 701, 175, 3, 119, "Section",ExpressionUUID->"01ce1230-e742-459f-97f6-b2dde836e46e"],
Cell[36869, 706, 793, 20, 189, "Text",ExpressionUUID->"b4d08552-959f-4dd0-8e8b-e009589c1cc5",
 InitializationCell->True],
Cell[37665, 728, 347, 7, 103, "Text",ExpressionUUID->"5ab0e818-5e3a-4d98-b051-04c411682e12"],
Cell[38015, 737, 474, 8, 146, "Text",ExpressionUUID->"c4c74716-52c6-441f-b5c2-d12a06ee316f"],
Cell[38492, 747, 710, 15, 146, "Text",ExpressionUUID->"15324f3c-7c7a-41d7-839d-77534fa356ad"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39251, 768, 188, 3, 61, "SlideShowNavigationBar",ExpressionUUID->"9d849a47-dc4c-4960-a2b3-5251a445cca8",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[39464, 775, 189, 3, 119, "Section",ExpressionUUID->"f1273ee5-3ee3-4a14-b492-85568a939dea"],
Cell[39656, 780, 245, 6, 103, "Text",ExpressionUUID->"7c5c09f7-0667-40e5-aa45-f04524b0283c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39950, 792, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"876955d7-7c08-4a9b-b335-e62f32462524",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[40097, 798, 325, 7, 119, "Section",ExpressionUUID->"22fb02b5-cbc0-4b90-9450-204f41a870fc"],
Cell[40425, 807, 180, 3, 60, "Text",ExpressionUUID->"20357dc6-0c0e-4524-ae71-c879271561a8"],
Cell[40608, 812, 258, 6, 101, "Item",ExpressionUUID->"c4da5934-8c94-49a4-b640-305859be84ef"],
Cell[40869, 820, 269, 6, 101, "Item",ExpressionUUID->"9f4a8172-c7b5-4450-8803-a5235d7a127e"],
Cell[41141, 828, 256, 6, 103, "Text",ExpressionUUID->"02191da3-427b-41b0-9042-ca3fa55a2816"],
Cell[41400, 836, 403, 8, 146, "Text",ExpressionUUID->"a8480774-2e07-4c1b-8e43-8651f16e80bc"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41852, 850, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"d0653087-e6fc-4117-98fa-618b3d35e3ba",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[41999, 856, 324, 7, 119, "Section",ExpressionUUID->"748d284b-6ee0-4ac7-9756-ff29a9b02b30"],
Cell[42326, 865, 604, 12, 189, "Text",ExpressionUUID->"c0760fec-2c98-4e68-bfc9-10fb8c0c6fad"],
Cell[42933, 879, 1993, 45, 507, "Input",ExpressionUUID->"f70bd1bf-3410-4669-bdc1-e6dd2d18f852"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[44975, 930, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"1aee3a95-fbc0-498b-abd0-c921a035505b",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[45122, 936, 193, 3, 119, "Section",ExpressionUUID->"05e7ef2d-d584-4f5c-8df1-474e57694088"],
Cell[45318, 941, 2356, 46, 427, "Input",ExpressionUUID->"92ad768a-2028-4c6e-8b36-5beca18aac5a"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[47723, 993, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"49daebd4-e7c9-47c2-82bb-31039aa26db5",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[47870, 999, 230, 4, 119, "Section",ExpressionUUID->"74215396-e667-45fd-a769-795ec7ca0f26"],
Cell[48103, 1005, 689, 17, 146, "Text",ExpressionUUID->"7fba4c40-815f-4f03-8617-094c7c6b96bf"],
Cell[48795, 1024, 391, 8, 146, "Text",ExpressionUUID->"164f0dec-913b-41a3-ab6b-ac10ee061bfd"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49235, 1038, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"3b5189f8-608c-47e2-b609-5d995e10fb40",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[49382, 1044, 170, 3, 119, "Section",ExpressionUUID->"a7743bc4-b8ab-4780-8f41-67555bfb2770"],
Cell[CellGroupData[{
Cell[49577, 1051, 170, 2, 52, "Input",ExpressionUUID->"d904ae87-bd19-48a9-8df5-be127aba5a59"],
Cell[49750, 1055, 1863, 35, 483, "Output",ExpressionUUID->"246525a2-9768-4851-8c6a-b2dcd064bf1e"]
}, Open  ]],
Cell[51628, 1093, 893, 16, 187, "Text",ExpressionUUID->"7fa708c2-8646-4798-9621-3325c3ffcd7b"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[52570, 1115, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"3dd70ad0-b846-4c51-8188-c3ca533c31be",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[52717, 1121, 161, 3, 119, "Section",ExpressionUUID->"5f0aa436-2c14-4579-8da5-501f76cd57db"],
Cell[52881, 1126, 257, 6, 103, "Text",ExpressionUUID->"7c8ee2de-beef-4871-82aa-d31f0bd43f3a"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[53187, 1138, 122, 2, 61, "SlideShowNavigationBar",ExpressionUUID->"347492f0-43b8-4a6f-9147-e2131bc5585a",
 CellTags->"SlideShowHeader"],
Cell[53312, 1142, 154, 3, 119, "Section",ExpressionUUID->"59086f0b-6f7c-453d-a2bd-1fd4ab461bbd"]
}, Open  ]]
}
]
*)

